org.apache.poi.ss.formula.eval

## Class RefEvalBase

- java.lang.Object
- - org.apache.poi.ss.formula.eval.RefEvalBase

- All Implemented Interfaces:
    RefEval, ValueEval, SheetRange
  Direct Known Subclasses:
    LazyRefEval

      public abstract class RefEvalBase
      extends java.lang.Object
      implements RefEval

  Common base class for implementors of `RefEval`

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `RefEvalBase(int onlySheetIndex, int rowIndex, int columnIndex)`
    `protected` | `RefEvalBase(int firstSheetIndex, int lastSheetIndex, int rowIndex, int columnIndex)`
    `protected` | `RefEvalBase(SheetRange sheetRange, int rowIndex, int columnIndex)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getColumn()` returns the zero based column index.
    `int` | `getFirstSheetIndex()` returns the first sheet index this applies to
    `int` | `getLastSheetIndex()` returns the last sheet index this applies to, which will be the same as the first for a 2D and many 3D references
    `int` | `getNumberOfSheets()` returns the number of sheets this applies to
    `int` | `getRow()` returns the zero based row index.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.poi.ss.formula.eval.RefEval

      `getInnerValueEval, offset`

- - ### Constructor Detail

    - #### RefEvalBase

          protected RefEvalBase(SheetRange sheetRange,
                                int rowIndex,
                                int columnIndex)

    - #### RefEvalBase

          protected RefEvalBase(int firstSheetIndex,
                                int lastSheetIndex,
                                int rowIndex,
                                int columnIndex)

    - #### RefEvalBase

          protected RefEvalBase(int onlySheetIndex,
                                int rowIndex,
                                int columnIndex)

  - ### Method Detail

    - #### getNumberOfSheets

          public int getNumberOfSheets()

      Description copied from interface: `RefEval`
      returns the number of sheets this applies to
      Specified by:
        `getNumberOfSheets` in interface `RefEval`

    - #### getFirstSheetIndex

          public int getFirstSheetIndex()

      Description copied from interface: `RefEval`
      returns the first sheet index this applies to
      Specified by:
        `getFirstSheetIndex` in interface `RefEval`
      Specified by:
        `getFirstSheetIndex` in interface `SheetRange`

    - #### getLastSheetIndex

          public int getLastSheetIndex()

      Description copied from interface: `RefEval`
      returns the last sheet index this applies to, which will be the same as the first for a 2D and many 3D references
      Specified by:
        `getLastSheetIndex` in interface `RefEval`
      Specified by:
        `getLastSheetIndex` in interface `SheetRange`

    - #### getRow

          public final int getRow()

      Description copied from interface: `RefEval`
      returns the zero based row index.
      Specified by:
        `getRow` in interface `RefEval`

    - #### getColumn

          public final int getColumn()

      Description copied from interface: `RefEval`
      returns the zero based column index.
      Specified by:
        `getColumn` in interface `RefEval`

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.